---
#-----------------------------------------------------------------------------#
# ansible-yunohost allows to deploy Yunohost using Ansible                    #
# Copyright 2021-present Lydra https://www.lydra.fr/                          #
#                                                                             #
# this program is free software: you can redistribute it and/or modify        #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation, either version 3 of the License, or           #
# (at your option) any later version.                                         #
#                                                                             #
# this program is distributed in the hope that it will be useful,             #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                #
# GNU General Public License for more details.                                #
#                                                                             #
# You should have received a copy of the GNU General Public License           #
# along with this program. If not, see <http://www.gnu.org/licenses/>.        #
#                                                                             #
#-----------------------------------------------------------------------------#

- name: Create backup folder
  ansible.builtin.file:
    path: "{{ ynh_backup.directory | default('/home/yunohost.backup/archives') }}"
    state: directory
    mode: '0750'
  tags:
    - backup

- name: Create backup script
  ansible.builtin.template:
    src: "{{ ynh_backup.src_script | default('templates/ynh_backup.sh.j2') }}"
    dest: "{{ ynh_backup.dest_script | default('/usr/local/bin/') }}ynh_backup.sh"
    owner: root
    group: root
    mode: '0740'
  tags:
    - backup
    - cron

- name: Create cron task to schedule YNH backup script
  ansible.builtin.cron:
    name: "auto-backup to {{ ynh_backup.directory | default('/home/yunohost.backup/archives') }}"
    month: "{{ ynh_backup.scheduled_month | default('*') }}"
    weekday: "{{ ynh_backup.scheduled_weekday | default('*') }}"
    hour: "{{ ynh_backup.scheduled_hour | default('1') }}"
    minute: "{{ ynh_backup.scheduled_minute | default('0') }}"
    user: root
    job: "{{ ynh_backup.dest_script | default('/usr/local/bin/') }}ynh_backup.sh"
    cron_file: ynh_backup_cron
  tags:
    - backup
    - cron
